;
;	 RLC
;                
;		 
;		1.0
;	 	09/07/2007
;
;1.    
;2.    
;3.     Displ Ubat        
;4.      POWER
;5.    100ms
;6.     100      100,   -     100
;	    PIC16F876
;***************************************************************************************
;* *             *   
;***************************************************************************************

; 1    *  MCLR/Vpp         * 
; 2    *  RA0/AN0          *  
; 3    *  RA1/AN1          *  Ubat * 2/(2+13)
; 4    *  RA2/AN2/Vref-    * . POWER
; 5    *  RA3/AN3/Vref+    * Ref 2.5V
; 6    *  RA4/T0CKI        * . .-. /"+"
; 7    *  RA5/AN4/SS       * .   RLC-Z-Y-Q-D/"-"
; 8    *  Vss              * GND
; 9    *  OSC1/CLKIN       *  20 
; 10   *  OSC2/CLKOUT      *  20 
; 11   *  RC0/T1OSO/T1CKI  * . Freq/Set
; 12   *  RC1/T1OSI/CCP2   *  100/1000 ()
; 13   *  RC2/CCP1         * "0" - =1, "1" - =10 -  
; 14   *  RC3/SCK/SCL      * "0" - =1, "1" - =10 -  

; 15   *  RC4/SDI/SDA      *  "0" - 100  "1" - 1
; 16   *  RC5/SDO          * "0" - , "1" - 
; 17   *  RC6/TX/CK        * "0" - 100 , "1" - 100k  
; 18   *  RC7/RX/DT        * "0" - PWR OFF, "1" - PWR ON
; 19   *  Vss              * +5V
; 20   *  Vdd              * GND
; 21   *  RB0/INT          * LCD_D4
; 22   *  RB1              * LCD_D5
; 23   *  RB2              * LCD_D6
; 24   *  RB3/PGM          * LCD_D7
; 25   *  RB4              * LCD_R/S
; 26   *  RB5              * LCD_E
; 27   *  RB6/PGC          *
; 28   *  RB7/PGD          *

;****************************************************************************************

Port_A_Config	equ 0xFF
; Port A bit equates
Kn_Freq  		equ	0
Kn_F_P  		equ	4
Kn_Disp  		equ	5
POWER		equ	2		;   

Kn_ALL_UP		equ	b'00110101'

Port_B_Config	equ b'11000000'

Port_C_Config	equ b'00000001'
; Port C bit equates
Kg_1			equ 3	;  0-=1, 1-=10
Kg_2			equ 2	;  0-=1, 1-=10
f_100_1k		equ 4	; "0" - 100  "1" - 1
U_I				equ 5	; 0-U, 1-I
Rsh				equ	6	; R    0-100 , 1-100
PWR_ON			equ	7	;"0" - PWR OFF, "1" - PWR ON
Sine_out	equ 1

;****************************************************************************************


	 list      p=PIC16F876A
     #include  P16F876A.inc ;	; 20.000 MHz
	__CONFIG _CP_OFF & _BODEN_OFF & _HS_OSC & _WRT_OFF & _WDT_OFF & _PWRTE_ON & _DEBUG_OFF & _CPD_OFF & _LVP_OFF


	#define	_RS	    PORTB,4
	#define	_E	    PORTB,5

;  Flags
go_m		equ 0	;    ,
					;  ,    
start_m		equ 1	;  20-  .
					;    
freq		equ	2	;0-100Hz, 1-1kHz
f_p			equ 3	;0-  , 1-
long_btn	equ 4	; 
calibr		equ 5	; open/short 
debug		equ	6	; 
L_Z			equ	7	;    
;    :
const_change	equ 2	; 



;  Flags_D
d_RLC		equ	0	; R  L/C
d_Z			equ	1	;  
d_Y			equ	2	;  
d_Q			equ	3	; 
d_D			equ	4	;   
;d_UI		equ	3	;    ( )

	CBLOCK 0x35 ;0x20-0x34 for FLOATING POINT LIBRARY
	;	 
	Flags
	Sine_step
	Sine_val
	
	Dly0  ;Stores 3 bytes of data for the delay count
	Dly1  ;Dly0 is the least significant byte
	Dly2  ;while Dly3 is the most significant byte	
	
	BCD0	;  
	BCD1
	BCD2
	BCD3
	BCD4	;  
	
	T0
	T1
	Temp_LCD
	Count1
	Count2
	Temp1
	Temp2
	Temp3
	NZ	;       
	
	Count_ADC ;    
	
	;    - 
	X3
	X2
	X1
	X0
	Y3
	Y2
	Y1
	Y0
	;--------------------------
	;   
	U_Re3	;,  ,  
	U_Re2
	U_Re1
	U_Re0	;,  ,  
	U_Im3	;,  ,  
	U_Im2
	U_Im1
	U_Im0	;,  ,  
	
	I_Re3	;,  ,  
	I_Re2
	I_Re1
	I_Re0	;,  ,  
	I_Im3	;,  ,  
	I_Im2
	I_Im1
	I_Im0	;,  ,  
	
	Z_Re3	;,  ,  
	Z_Re2
	Z_Re1
	Z_Re0	;,  ,  
	Z_Im3	;,  ,  
	Z_Im2
	Z_Im1
	Z_Im0	;,  ,  
	
	Num_p	; 
	f_tmp
	f_tmp2		
	;--------------------------
	EE_ADR	;     EEPROM
	EE_DATA
	K_U		;-     (1-=1, 2-=10, 3-=100)
	K_I		;-     (1-=1, 2-=10, 3-=100)

	
	ENDC
	
	CBLOCK 0x71
	;   
	STATUS_TEMP
	PCLATH_TEMP
	W_TEMP
	;-------------
	Flags_D
	ENDC
	
	CBLOCK 0xF1
	W_TEMP1		;   
	ENDC
	
	CBLOCK 0xA0
	ADC_val:2*.20	;   20-  
	Btn_old	;   
	Btn_now
	Btn_sw	;  
	Btn_time1
	Btn_time2
	Auto_off_time
	ENDC
	
	
;=========================
;       
;=========================
Dly24 MACRO DLY
;Take the delay value argument from the macro, precalculate
;the required 3 RAM values and load the The RAM values Dly2,Dly1 
;and Dly0.
	banksel Dly0
	movlw   DLY & H'FF'
	movwf   Dly0
	movlw   DLY >>D'08' & H'FF'
	movwf   Dly1
	movlw   DLY >>D'16' & H'FF'
	movwf   Dly2
;Bytes are shifted and anded by the assembler to make user 
;calculations easier.
	endm
	
;==========================
	ORG		0x2100   	;  EEPROM
;					; 	 EEPROM
K_E_1		DE	0x7B, 0x4C, 0xCC, 0xCD	;0.1
K_E_2		DE	0x78, 0x23, 0xD7, 0x0A	;0.01

;-   1000 , .. -   (USR_100)    1000 
K_Rsh_0		DE	0x82, 0x20, 0x00, 0x00	; (1/100)*1000=10
K_Rsh_1		DE	0x78, 0x23, 0xD7, 0x0A	; (1/100000)*1000=0.01

w_100		DE	0x88, 0x1D, 0x14, 0x62	;2*Pi*f=6283,185307 ( 1kHz)
w_1000		DE	0x8B, 0x44, 0x59, 0x7C	;2*Pi*f=6283,185307 ( 1kHz)

;    
; 100
Zs_Re_100	DE	0, 0, 0, 0	;Short
Zs_Im_100	DE	0, 0, 0, 0	;Short
Yo_Re_100	DE	0, 0, 0, 0	;Open
Yo_Im_100	DE	0, 0, 0, 0	;Open
; 1
Zs_Re_1k	DE	0, 0, 0, 0	;Short
Zs_Im_1k	DE	0, 0, 0, 0	;Short
Yo_Re_1k	DE	0, 0, 0, 0	;Open
Yo_Im_1k	DE	0, 0, 0, 0	;Open

USR_100		dt	0x00, 0x00, 0x03, 0xE8	; 0x3E8=1000
USR_100k	dt	0x00, 0x00, 0x03, 0xE8	; 0x3E8=1000

K_Ubat		dt	0x79, 0x16, 0x28, 0xCC	; k=9V/491=0.01822

		org 	0x00 
;*******************************************************************************
;                              
;******************************************************************************* 	
		nop			;for MPLAB-ICD2
		goto		init
;------------------ Interrupt ------------------
		org		0x004

		movwf   W_TEMP		;save W
		swapf   STATUS,W	;swap STATUS, W
		clrf	STATUS		; 0
		movwf   STATUS_TEMP	;save status
		movf	PCLATH,W
		movwf	PCLATH_TEMP	;save PCLFTH
		
		pagesel	$
		call	Load_Sine_Val
		btfss	Flags, start_m
		goto	tst_go_m

;---  ---
		bsf		ADCON0,GO	; - 
		btfsc		ADCON0,GO
		goto		$-1		;   
		;     
		incf		FSR, F	;   
		banksel		ADRESL
		movf		ADRESL,W
		addwf		INDF, F	;   
		decf		FSR, F	;    
		btfsc		STATUS, C	;    ?
		incf		INDF, F	;   
		banksel		ADRESH
		movf		ADRESH,W
		addwf		INDF, F	;   
		incf		FSR
		incf		FSR		;   .  
		decfsz		Count_ADC, F
		goto		btn_check
		movlw		ADC_val	;   
		movwf		FSR	;      
		movlw		.20	;  20   
		movwf		Count_ADC	;    
		decfsz		Num_p, F	; 
		goto		btn_check
		; ,  
		bcf		Flags, start_m
		bcf		Flags, go_m
		
tst_go_m
		;       
		btfss	Flags, go_m
		goto	btn_check
		movlw	.1			;  Sine_step=1,  
		subwf	Sine_step,W	;   ,   
		btfsc	STATUS, Z	;  Sine_step=20
		bsf	Flags, start_m ;    
		
btn_check
		; ,   
		bsf		STATUS, RP0	; 1
		incfsz	Btn_time1, F
		goto	restore_context	;255  

		clrf	STATUS		; 0
		movf	PORTA, W		; 50*255=12,75 ( 1 )
		bsf		STATUS, RP0	; 1
		andlw	Kn_ALL_UP		;  
		movwf	Btn_now		;      POWER
		bcf		Btn_now,Kn_Freq
		clrf	STATUS		; 0
		btfss	PORTC,Kn_Freq
		goto	ddr1
		banksel	Btn_now
		bsf	Btn_now,Kn_Freq
ddr1
		banksel	Btn_now
		movf	Btn_now,W
		subwf	Btn_old, W	;W = Btn_old - Btn_now
		btfss	STATUS, C
		goto	btn_up		;old < now   
		btfss	STATUS, Z	;old >= now
		goto	btn_end		;   
		movlw	Kn_ALL_UP
		subwf	Btn_now, W
		btfsc	STATUS, Z
		goto	btn_end	;  
		decfsz	Btn_time2	;    
		goto	btn_end

		;   "" 
		bcf		STATUS, RP0	; 0
		bsf		Flags, long_btn
		goto	btn_end

btn_up	;  
		movf	Btn_old, W
		movwf	Btn_sw
		bcf		STATUS, RP0	; 0
		movlw	.80
		btfss	Flags, freq
		movlw	.8	; 100 
		bsf		STATUS, RP0	; 1
		movwf	Btn_time2
btn_end
		movf	Btn_now, W
		movwf	Btn_old

restore_context
		clrf	STATUS		; 0
		bcf     PIR1,CCP1IF	;clear interrupt flag
		
		movf	PCLATH_TEMP,W
		movwf	PCLATH
		swapf	STATUS_TEMP,W	;fetch status, reswap nibbles
		movwf   STATUS			;restore status
		swapf   W_TEMP,F    ;swap nibbles in preparation
		swapf   W_TEMP,W    ;for the swap restoration of w
		retfie				;return from interrupt
;-----------------------------------------------

init
		banksel		INTCON
		clrf		INTCON
		clrf		PCLATH
		clrf		PORTA
		clrf		PORTB
		clrf		PORTC
		clrf		Flags_D
		clrf		Flags		; :
		movlw		1<<PWR_ON		;   
		movwf		PORTC


		bsf			Flags, freq	; 1
		bsf			Flags, f_p	;  
		bsf			Flags_D, d_RLC	;  R,L,C
		clrf		FPFLAGS
		bsf			FPFLAGS, RND ;    
		movlw		1
		movwf		K_U	;       1
		movwf		K_I
		
		; 
		banksel		ADCON1
		movlw		b'10000101'; , RA3=Vref+, Vss=Vref-, AN0, AN1 
		movwf		ADCON1
		movlw		Port_A_Config
		movwf		TRISA
		banksel		ADCON0
		movlw		b'10000001' ;Fosc/32,  AN0,   .
		movwf		ADCON0
		
		banksel		TRISB
		movlw		Port_B_Config
		movwf		TRISB
		movlw		Port_C_Config
		movwf		TRISC
		movlw		Kn_ALL_UP
		movwf		Btn_old
		movwf		Btn_sw
		clrf		Btn_time1
		movlw		.80	;    Fgen=1kHz
		movwf		Btn_time2
		clrf		Auto_off_time

;----------------------------------------
;	 LCD  4-  		
InitLCD
        call		Delay_5_ms
        call		Delay_5_ms
        call		Delay_5_ms ; 15    
		banksel		PORTB
		movlw		3
		movwf		Count1
		movwf		PORTB
SetLoop
        bsf		_E		;  LCD 3    0x30
		nop
		nop
		nop
		bcf		_E
		call		Delay_5_ms
		decfsz		Count1,f
		goto		SetLoop
		
		movlw		2		; 4-x 
		movwf		PORTB
		call		Send
		movlw		28		; 4- , 2 , 57
		call		CmdLCD
		movlw		0C		;  
		call		CmdLCD
		movlw		6		;   ,   
		call		CmdLCD
		call		Load_ZG ;     
        call		ClrDSP		;  

;---------   POWER-----------------------------------------

pwr_c10		call		Delay_05_sec	;   
		call		Delay_05_sec

		btfss		PORTA,2
		goto		pwr_c20
		call		Delay_01_sec	; 
		bcf		PORTC,PWR_ON	;     1  -  
		goto		$

pwr_c20		call		Disp_Ubat		;       
pwr_c30		btfss		PORTA,2		;    
		goto		pwr_c30
		call		Delay_01_sec	; 

;------------    ------------
		btfsc		PORTC,Kn_Freq	;    ?
		goto		Main			;
		goto		c_1		
Const_Loop
		btfsc		PORTA, POWER	;   
		goto		c_10
		call		Delay_01_sec	; 
		bcf			PORTC,PWR_ON
		goto		$

c_10	btfss		PORTA, Kn_F_P
		call		IncB

		btfss		PORTA, Kn_Disp
		call		DecB

		btfsc		PORTC, Kn_Freq
		goto		Const_Loop
		btfss		Flags, const_change	;  
		goto		c_3
		call		Save_Const	; ,  
c_3
		incf		Y0,F
		movf		Y0,W
		sublw		2	; 
		btfss		STATUS,Z
		goto		$+2
c_1		clrf		Y0
		bcf			Flags,const_change	;   
        call		ClrDSP		;  
	   	movlw		LOW _Const
		call		Read_String
		movlw 		HIGH $
		movwf 		PCLATH
        movf		Y0,W
        addwf		PCL,F ; 
        goto		c_100	;+0
        goto		c_100k	;+1

c_2		
		movwf		Y1	;  -     EEPROM
		pagesel		EEPROM_To_B
		call		EEPROM_To_B
		pagesel		$
		call		ShowX
        goto		Const_Loop

c_100
		movlw		1	; 
		call		CharLCD
		movlw		LOW USR_100
		goto		c_2
c_100k
		movlw		"k"	; 
		call		CharLCD
		movlw		1	; k
		call		CharLCD
		movlw		LOW USR_100k
		goto		c_2

;----------------------------------------

;----------------------------------------
Main
PWM_init
		banksel		PR2
		movlw		.24 ; =(24+1)*.2=5  F=1/5=200
		movwf		PR2	; =200
		banksel		CCP2CON
		clrf		CCP2CON
		movlw		.20
		movwf		Sine_step
		call		Load_Sine_Val
		movlw		b'00000100' ;- =1
		movwf		T2CON		;. TMR2
		movlw		0x0F
		iorwf		CCP2CON,F	;. CCP2   

CCP1_init
		movlw		b'00000001'	;Fosc/4 = .2
		movwf		T1CON		; TMR1
		clrf		CCPR1H
		movlw		.249	;F=1, T=1, 20  => 1/20=50, 50/0.2=250
		movwf		CCPR1L
		movlw		b'00001011' ; ,  .
		movwf		CCP1CON
		
		banksel		PIE1
		movlw		b'00000100' ;    CCP1
		movwf		PIE1
		banksel		INTCON
		movlw		b'11000000'	;    
		movwf		INTCON

		call		Delay_05_sec	;        
		call		Delay_05_sec

;================================================
Measure

;================================================
;        
;------------------------------------------------
Measure_U
		bcf			PORTC, U_I	;0-U, 1-I
		call		Set_Kg		;  - 
		call		Delay_01_sec
		
		call		Make_ADC
		call		Chk_m	;  
		iorlw		0		;0 -   , 1 - , 2 - 
		btfss		STATUS, Z
		goto		u_2
u_1		call		DFT		;     
		goto		Measure_I
u_2		
		xorlw		1
		btfss		STATUS, Z
		goto		u_3		;2-
		call		Inc_K_U	;1-
		iorlw		0
		btfsc		STATUS, Z
		goto		u_1	;0-  ,    
		goto		Measure_U
u_3		
		call		Dec_K_U	; 0 - , 1-OK
		iorlw		0
		btfss		STATUS, Z
		goto		Measure_U
		call		ClrDSP
		movlw		"U"
		call		CharLCD
		call		DispSP
		movlw		LOW _ADC_ovl
		call		Read_String
		call		Delay_05_sec
		goto		Measure_U
;================================================
;       
;------------------------------------------------	
Measure_I
		bsf			PORTC, U_I	;0-U, 1-I
		call		Set_Kg		;  - 
		call		Delay_01_sec


		call		Make_ADC		
		call		Chk_m	;  
		iorlw		0		;0 -   , 1 - , 2 - 
		btfss		STATUS, Z
		goto		i_2
i_1		call		DFT		;     
		goto		mlt_0
i_2		
		xorlw		1
		btfss		STATUS, Z
		goto		i_3		;2-
		call		Inc_K_I	;1-
		iorlw		0
		btfsc		STATUS, Z
		goto		i_1	;0-  ,    
		xorlw		1
		btfss		STATUS, Z
		goto		Measure_U	;2-    . Rsh,   
		goto		Measure_I	;1-   . Rsh,   
i_3		
		call		Dec_K_I
		iorlw		0
		btfss		STATUS, Z
		goto		Measure_I
		call		ClrDSP
		movlw		"I"
		call		CharLCD
		call		DispSP
		movlw		LOW _ADC_ovl
		call		Read_String
		call		Delay_05_sec
		goto		Measure_I
;----------------------------------------------
; U,I   -
mlt_0
;  Rsh=100 -> =0.01, Rsh=100 -> =0.00001
		movlw		I_Re0	;  
		movwf		f_tmp	;   
		movlw		low K_Rsh_1	;100kOm
		btfss		PORTC, Rsh	;0-100 , 1-100
		movlw		low K_Rsh_0	;100 Om
		movwf		f_tmp2	;    EEPROM
		call		Mult	; I_Re
		movlw		I_Im0	;  
		movwf		f_tmp	;   
		call		Mult	; I_Im
;  K_U  K_I
; 
		movlw		2
		subwf		K_I, W
		btfss		STATUS, Z
		goto		mlt_1
		movlw		LOW K_E_1
		movwf		f_tmp2
		goto		mlt_2
mlt_1
		movlw		3
		subwf		K_I, W
		btfss		STATUS, Z
		goto		mlt_3
		movlw		LOW K_E_2
		movwf		f_tmp2
mlt_2
		movlw		I_Re0
		movwf		f_tmp
		call		Mult
		movlw		I_Im0
		movwf		f_tmp
		call		Mult
;
mlt_3
		;    -  Rsh=100  100
		movlw		LOW USR_100k
		btfss		PORTC, Rsh
		movlw		LOW USR_100
		movwf		f_tmp2
		movlw		U_Re0
		movwf		f_tmp
		call		Mult_int
		movlw		U_Im0
		movwf		f_tmp
		call		Mult_int

		movlw		2
		subwf		K_U, W
		btfss		STATUS, Z
		goto		mlt_4
		movlw		LOW K_E_1
		movwf		f_tmp2
		goto		mlt_5
mlt_4
		movlw		3
		subwf		K_U, W
		btfss		STATUS, Z
		goto		mlt_6
		movlw		LOW K_E_2
		movwf		f_tmp2
mlt_5
		movlw		U_Re0
		movwf		f_tmp
		call		Mult
		movlw		U_Im0
		movwf		f_tmp
		call		Mult
		
mlt_6

;-----------------------------------------------
; J 
; RA2 - 100/1000 
; RA4 - / 
; RA5 - RLC, Z, Y
		banksel		Btn_sw
		movlw		Kn_ALL_UP
		subwf		Btn_sw, W
		btfsc		STATUS, Z
		goto		bt_end	;   
		banksel		Flags
		btfss		Flags, long_btn
		goto		bt_5
		bcf		Flags, long_btn

		banksel		Btn_sw
		btfsc		Btn_sw, POWER
		goto		bt_2a
		call		Delay_01_sec
		bcf		PORTC,PWR_ON	;    
		goto	$

bt_2a		btfsc		Btn_sw, Kn_F_P
		goto		bt_4
		banksel		Flags	;  OPEN 
		bsf			Flags, f_p	;  
bt_3
		clrf		Flags_D
		bsf			Flags_D, d_RLC	;  RLC
		bsf			Flags, calibr	;  
		goto		bt_end
bt_4
		btfsc		Btn_sw, Kn_Disp
		goto		bt_4a
		banksel		Flags	;  SHORT 
		bcf			Flags, f_p	;  
		goto		bt_3
bt_4a
		btfsc		Btn_sw, Kn_Freq
		goto		bt_end
		banksel		Flags	;   
		movlw		1 << debug
		xorwf		Flags, F	; 
		goto		bt_end
		
bt_5
		btfss		Flags, calibr
		goto		bt_7
		bcf			Flags, calibr
		banksel		Btn_sw
		btfsc		Btn_sw, Kn_Freq
		goto		bt_7
		call		Save_Zin	;    EEPROM
		call		ClrDSP
		movlw		LOW _Saved
		call		Read_String
		banksel		Btn_sw
		movlw		Kn_ALL_UP
		movwf		Btn_sw
		banksel		Flags
		goto		Disp_end_2
		
;-----------
bt_7
		banksel		Btn_sw
		movf		Btn_sw, W
		banksel		Temp1
		movwf		Temp1

		btfsc		Temp1, POWER
		goto		bt_7a
		call		Delay_01_sec
		bcf		PORTC,PWR_ON	;    
		goto	$

bt_7a		btfsc		Temp1, Kn_Freq	;100/1000 
		goto		bt_1
		movlw		1 << freq
		xorwf		Flags, F	;  
		call		set_freq
		
bt_1		btfsc		Temp1, Kn_F_P	;/ 
		goto		bt_2
		movlw		1 << f_p
		xorwf		Flags, F	; 

bt_2		btfsc		Temp1, Kn_Disp	;RLC, Z, Y
		goto		bt_end
		btfss		Flags_D, d_D	;  
		goto		next_disp
		movlw		1
		movwf		Flags_D
		goto		bt_end
next_disp
		bcf			STATUS, C
		rlf			Flags_D, F
bt_end	
		banksel		Btn_sw
		movlw		Kn_ALL_UP
		movwf		Btn_sw
		banksel		Flags

;-----------------------------------------------
;  Zx, Yx

		btfss		Flags, calibr	;     
		goto		calc_comp
		btfsc		Flags, f_p	;0-  , 1-
		call		Swap_UI		;     U  I
		call		Div_UI		; U/I,    Z   Y
		goto		mlt_7
calc_comp		
		call		Div_UI		; U/I,    Z   Y
		call		Comp_Zin	;   
		
mlt_7
;------    ------
		call		ClrDSP
		btfss		Flags, f_p
		goto		chk_f
		btfss		Flags_D, d_RLC
		goto		$+2
		goto		Disp_RLC_p	; RLC,  
		btfss		Flags_D, d_Z
		goto		$+2
		goto		Disp_Z_p	; Z  
		btfss		Flags_D, d_Y
		goto		$+2
		goto		Disp_Y_p	; Y,  
		btfss		Flags_D, d_Q
		goto		Disp_D_p	; D,  
		goto		Disp_Q_p	; Q,  
		
chk_f
		btfss		Flags_D, d_RLC
		goto		$+2
		goto		Disp_RLC_f	; RLC,  
		btfss		Flags_D, d_Z
		goto		$+2
		goto		Disp_Z_f	; Z  
		btfss		Flags_D, d_Y
		goto		$+2
		goto		Disp_Y_f	; Y,  
		btfss		Flags_D, d_Q
		goto		Disp_D_f	; D,  
		goto		Disp_Q_f	; Q,  

;------   -  U  I ------
;Disp_UI
;		movlw		U_Re0
;		call		Disp_val
;		call		DispSP
;		movlw		U_Im0
;		call		Disp_val
		
;		call		SecLine
;		movlw		I_Re0
;		call		Disp_val
;		call		DispSP
;		movlw		I_Im0
;		call		Disp_val
;		goto		Disp_end

;------  RLC,   ------
Disp_RLC_p
		movlw		"R"
		call		CharLCD
		movlw		"p"
		call		CharLCD
		call		DispSP
		movlw		LOW E0	;  1
		pagesel		Prog_To_A
		call		Prog_To_A
		movlw		Z_Re0
		call		Copy_To_B
		call		FPD32	;A=A/B
		pagesel		$
		call		Disp_A
		movlw		1	; 
		call		CharLCD
disp_LC_p		
		call		SecLine
		btfss		Z_Im1,7	; : "+"  C, "-"  L
		goto		disp_Cp	; 
		bcf			Z_Im1,7	; ,  "-"
		movlw		LOW w_1000	;Lp=1/(w*Bp)
		btfss		Flags, freq	;0-100Hz, 1-1kHz
		movlw		LOW w_100
		pagesel		EEPROM_To_B
		call		EEPROM_To_B
		movlw		Z_Im0
		call		Copy_To_A
		call		FPM32	;A=w*Bp
		call		BEQUA	;B=A
		movlw		LOW E0	;  1
		call		Prog_To_A
		call		FPD32	;A=A/B
		pagesel		$
		movlw		"L"
		call		CharLCD
		movlw		"p"
		call		CharLCD
		call		DispSP
		call		Disp_A
		movlw		"H"		;
		call		CharLCD
		goto		Disp_end
		
disp_Cp				;Cp=Bp/w
		movlw		LOW w_1000	;Lp=1/(w*Bp)
		btfss		Flags, freq	;0-100Hz, 1-1kHz
		movlw		LOW w_100
		pagesel		EEPROM_To_B
		call		EEPROM_To_B
		movlw		Z_Im0
		call		Copy_To_A
		call		FPD32	;A=Bp/w
		pagesel		$
		movlw		"C"
		call		CharLCD
		movlw		"p"
		call		CharLCD
		call		DispSP
		call		Disp_A
		movlw		"F"		;
		call		CharLCD
		goto		Disp_end
		
;------  Y,   ------
Disp_Y_p
		movlw		"G"
		call		CharLCD
		movlw		"p"
		call		CharLCD
		call		DispSP
		movlw		Z_Re0
		call		Disp_val
		movlw		"S"		;
		call		CharLCD
		call		SecLine
		movlw		"B"
		call		CharLCD
		movlw		"p"
		call		CharLCD
		call		DispSP
		movlw		Z_Im0
		call		Disp_val
		movlw		"S"		;
		call		CharLCD
		goto		Disp_end	

;------  Z   ------
Disp_Z_p
		movlw		"R"
		call		CharLCD
		movlw		"p"
		call		CharLCD
		call		DispSP
		movlw		LOW E0	;  1
		pagesel		Prog_To_A
		call		Prog_To_A
		movlw		Z_Re0
		call		Copy_To_B
		call		FPD32	;A=A/B
		pagesel		$
		call		Disp_A
		movlw		1	; 
		call		CharLCD
		
		call		SecLine
		movlw		"X"
		call		CharLCD
		movlw		"p"
		call		CharLCD
		call		DispSP
		movlw		LOW E0	;  1
		pagesel		Prog_To_A
		call		Prog_To_A
		movlw		Z_Im0
		call		Copy_To_B
		call		FPD32	;A=A/B
		pagesel		$
		movlw		b'10000000'
		xorwf		AARGB0, F	;  -/+
		call		Disp_A
		movlw		1	; 
		call		CharLCD
	
		goto		Disp_end	
;------  RLC,   ------
Disp_RLC_f
		movlw		"R"
		call		CharLCD
		movlw		"s"
		call		CharLCD
		call		DispSP
		movlw		Z_Re0
		call		Disp_val
		movlw		1	; 
		call		CharLCD
disp_LC_f		
		call		SecLine
		btfss		Z_Im1,7	; Xs: "-"  C, "+"  L
		goto		disp_Ls	; 
		bcf			Z_Im1,7	; ,  "-"
		movlw		LOW w_1000	;Cs=1/(w*Xs)
		btfss		Flags, freq	;0-100Hz, 1-1kHz
		movlw		LOW w_100
		pagesel		EEPROM_To_B
		call		EEPROM_To_B
		movlw		Z_Im0
		call		Copy_To_A
		call		FPM32	;A=w*Xs
		call		BEQUA	;B=A
		movlw		LOW E0	;  1
		call		Prog_To_A
		call		FPD32	;A=1/(w*Xs)
		pagesel		$
		movlw		"C"
		call		CharLCD
		movlw		"s"
		call		CharLCD
		call		DispSP
		call		Disp_A
		movlw		"F"		;
		call		CharLCD
		goto		Disp_end
		
disp_Ls				;Ls=Xs/w
		movlw		LOW w_1000
		btfss		Flags, freq	;0-100Hz, 1-1kHz
		movlw		LOW w_100
		pagesel		EEPROM_To_B
		call		EEPROM_To_B
		movlw		Z_Im0
		call		Copy_To_A
		call		FPD32	;A=Xs/w
		pagesel		$
		movlw		"L"
		call		CharLCD
		movlw		"s"
		call		CharLCD
		call		DispSP
		call		Disp_A
		movlw		"H"		;
		call		CharLCD
		goto		Disp_end	

;------  Y,   ------
Disp_Y_f
		movlw		"G"
		call		CharLCD
		movlw		"s"
		call		CharLCD
		call		DispSP
		movlw		LOW E0	;  1
		pagesel		Prog_To_A
		call		Prog_To_A
		movlw		Z_Re0
		call		Copy_To_B
		call		FPD32	;A=A/B
		pagesel		$
		call		Disp_A
		movlw		"S"	;
		call		CharLCD
		
		call		SecLine
		movlw		"B"
		call		CharLCD
		movlw		"s"
		call		CharLCD
		call		DispSP
		movlw		LOW E0	;  1
		pagesel		Prog_To_A
		call		Prog_To_A
		movlw		Z_Im0
		call		Copy_To_B
		call		FPD32	;A=A/B
		pagesel		$
		movlw		b'10000000'
		xorwf		AARGB0, F	;  -/+
		call		Disp_A
		movlw		"S"	;
		call		CharLCD
		goto		Disp_end

;------  Z,   ------
Disp_Z_f
		movlw		"R"
		call		CharLCD
		movlw		"s"
		call		CharLCD
		call		DispSP
		movlw		Z_Re0
		call		Disp_val
		movlw		1	; 
		call		CharLCD
		call		SecLine
		movlw		"X"
		call		CharLCD
		movlw		"s"
		call		CharLCD
		call		DispSP
		movlw		Z_Im0
		call		Disp_val
		movlw		1	; 
		call		CharLCD
		goto		Disp_end	
;------  Q ------
Disp_Q_p
Disp_Q_f
		movlw		"Q"
		call		CharLCD
		call		DispSP
		pagesel		Copy_To_A
		movlw		Z_Im0
		call		Copy_To_A
		movlw		Z_Re0
		call		Copy_To_B
		call		FPD32	;Q=Bp/Gp
		movlw		b'01111111'
		andwf		AARGB0, F	;  
		pagesel		$
		call		Disp_A
		btfss		Flags, f_p
		goto		disp_LC_f
		goto		disp_LC_p
;------  D ------
Disp_D_p
Disp_D_f
		movlw		"D"
		call		CharLCD
		call		DispSP
		pagesel		Copy_To_A
		movlw		Z_Re0
		call		Copy_To_A
		movlw		Z_Im0
		call		Copy_To_B
		call		FPD32	;Q=Gp/Bp
		movlw		b'01111111'
		andwf		AARGB0, F	;  
		pagesel		$
		call		Disp_A
		btfss		Flags, f_p
		goto		disp_LC_f
		goto		disp_LC_p

;------------------------
Disp_val	;       
		pagesel		Copy_To_A
		call		Copy_To_A
		pagesel		$
		call		Disp_A
		return
;------------------------
Disp_end
		btfss		Flags, debug
		goto		Disp_end_1
		movlw		0xC0+.13
		call		CmdLCD
		movlw		"K"
		btfss		PORTC, Rsh
		movlw		1	;
		call		CharLCD
		movf		K_U, W
		call		NumLCD
		movf		K_I, W
		call		NumLCD
Disp_end_1
		movlw		0x80+.13
		call		CmdLCD
		movlw		LOW _1k
		btfss		Flags, freq
		movlw		LOW _100
		call		Read_String

		btfss		Flags, calibr
		goto		Disp_end_2
		movlw		0xC0+.11
		call		CmdLCD
		movlw		LOW _open
		btfss		Flags, f_p
		movlw		LOW _short
		call		Read_String
Disp_end_2
		banksel		Auto_off_time
		incfsz		Auto_off_time, F
		goto		Disp_end_3
		banksel		PORTC
		bcf			PORTC, PWR_ON	;  
Disp_end_3
		banksel		Flags
		btfsc		Flags, freq
		call		Delay_05_sec ;  100  
		goto		Measure

		
;===================================
;  
; f_tmp2 -     EEPROM
; f_tmp -   
;    ,   f_tmp
Mult
		movf		f_tmp2, W
		pagesel		EEPROM_To_B
		call		EEPROM_To_B
mult_B
		pagesel		Copy_To_A
		movf		f_tmp, W
		call		Copy_To_A
		call		FPM32
		movf		f_tmp, W
		call		Copy_From_A
		pagesel		$
		return
;  ,    f_tmp2   
; int  float
Mult_int
		movf		f_tmp2, W
		pagesel		EEPROM_To_A
		call		EEPROM_To_A
		call		FLO32
		call		BEQUA
		pagesel		$
		goto		mult_B

;======================================================
;    40   ( )
;------------------------------------------------------
Make_ADC
		pagesel		Clr_ADC
		call		Clr_ADC
		pagesel		$
		movlw		ADC_val
		movwf		FSR	;      
		movlw		.20	;  20   
		movwf		Count_ADC	;    
		movlw		.40		; 40   1, . 40
		movwf		Num_p	;    50
		bsf			Flags, go_m	; 
		btfsc		Flags, go_m
		goto		$-1	;   
		return
;======================================================
;    
;======================================================
Reset_auto_off_time
		banksel		Auto_off_time
		clrf		Auto_off_time
		banksel		STATUS
		return

;======================================================
;  -    
; : 0 -   
;		 1 -    . Rsh
;		 2 -     . Rsh
;------------------------------------------------------
Inc_K_I
		; Rsh=100,  . =10,     100k
		movlw		2	;  = 10
		btfsc		PORTC, Rsh	;0 - R=100 , 1 - R=100k
		movlw		3
		subwf		K_I, W
		btfss		STATUS, Z
		goto		next_KI
		btfsc		PORTC, Rsh	;0 - R=100 , 1 - R=100k
		retlw		0	; -  
		call		Reset_auto_off_time
		bsf			PORTC, Rsh	;  R=100k
		movlw		1
		movwf		K_I	; =1
		retlw		2	;     . Rsh
next_KI
		call		Reset_auto_off_time
		incf		K_I, F
		retlw		1	;    . Rsh

;======================================================
;  -    
; : 0 -   
;		 1 -    . Rsh
;		 2 -     . Rsh
;------------------------------------------------------
Inc_K_U
		; Rsh=100k,  . =10,     100 
		movlw		2	;  = 10
		btfss		PORTC, Rsh	;0 - R=100 , 1 - R=100k
		movlw		3	;  = 100
		subwf		K_U, W
		btfss		STATUS, Z
		goto		next_KU
		btfss		PORTC, Rsh	;0 - R=100 , 1 - R=100k
		retlw		0	; -  
		call		Reset_auto_off_time
		bcf			PORTC, Rsh ; R=100 
		movlw		1
		movwf		K_U	; =1
		retlw		2	;     . Rsh
next_KU
		call		Reset_auto_off_time
		incf		K_U, F
		retlw		1	;    . Rsh
;======================================================
;  -    
; : 0 - ,   
;		 1 -  
;------------------------------------------------------
Dec_K_I
		movlw		1
		subwf		K_I, W
		btfsc		STATUS, Z
		retlw		0
		call		Reset_auto_off_time
		decf		K_I, F
		retlw		1
;======================================================
;  -    
; : 0 - ,   
;		 1 -  
;------------------------------------------------------
Dec_K_U
		movlw		1
		subwf		K_U, W
		btfsc		STATUS, Z
		retlw		0
		call		Reset_auto_off_time
		decf		K_U, F
		retlw		1
;======================================================
;   - 
; 1-1, 2-10, 3-100
;------------------------------------------------------
Set_Kg
		movf		K_I, W
		btfss		PORTC, U_I	; 0-U, 1-I
		movf		K_U, W
		movwf		Temp1
		movlw		LOW tbl_go
		addwf		Temp1, F	;8    
		movlw		HIGH tbl_go	;5  
		btfsc		STATUS, C	;    0xFF ?
		addlw		1	; 
		movwf		PCLATH
		movf		Temp1, W
tbl_go
        movwf		PCL		; 
        goto		set_1
        goto		set_10
        goto		set_100
set_1
		bcf			PORTC, Kg_1
		goto		$+1
		bcf			PORTC, Kg_2
		return
set_10
		bsf			PORTC, Kg_1
		goto		$+1
		bcf			PORTC, Kg_2
		return
set_100
		bsf			PORTC, Kg_1
		goto		$+1
		bsf			PORTC, Kg_2
		return

;======================================================
;   
; 100  1000 
;------------------------------------------------------
set_freq
		movlw		.80
		btfss		Flags, freq	;0-100Hz, 1-1000Hz
		movlw		.8
		banksel		Btn_time2
		movwf		Btn_time2	;   
		banksel		Flags

		btfss		Flags, freq	;0-100Hz, 1-1000Hz
		goto		set_100Hz
		clrf		CCPR1H
		movlw		.249	;F=1, T=1, 20  => 1/20=50, 50/0.2=250
		movwf		CCPR1L
		bcf		PORTC, f_100_1k
		return
set_100Hz
		movlw		0x09	;F=100, T=10, 20  => 10/20=500, 500/0.2=2500, 2499=0x9C3
		movwf		CCPR1H
		movlw		0xC3
		movwf		CCPR1L
		bsf		PORTC, f_100_1k
		return
;======================================================
;  
; :
; 0 -   , 1 - , 2 - 
; Y0,Y1 - min  Y2,Y3 - max
;------------------------------------------------------
Chk_m
		movlw		ADC_val
		movwf		FSR
		movf		INDF, W
		movwf		Y0	; 
		movwf		Y2
		incf		FSR, F
		movf		INDF, W
		movwf		Y1	; 
		movwf		Y3
;--------------------------
chk_min
		incf		FSR, F
		movf		Y0, W
		subwf		INDF,W ;W=INDF-Y0
		btfss		STATUS, C
		goto		min_to_Y0	;     Y0
		btfss		STATUS, Z
		goto		chk_max
		incf		FSR, F	;  ,   
		movf		Y1, W
		subwf		INDF,W ;W=INDF-Y1
		btfss		STATUS, C
		goto		min_to_Y1	;     Y1
		decf		FSR, F
;--------------------------
chk_max
		movf		INDF, W
		subwf		Y2, W ;W=Y2-INDF
		btfss		STATUS, C
		goto		max_to_Y2	;     Y2
		btfss		STATUS, Z
		goto		chk_end2
		incf		FSR, F	;  ,   
		movf		INDF, W
		subwf		Y3, W ;W=Y1-INDF
		btfss		STATUS, C
		goto		max_to_Y3	;     Y1
		goto		chk_end
;--------------------------
chk_end2
		incf		FSR, F
chk_end
		movlw		ADC_val+.39
		subwf		FSR, W
		btfss		STATUS, Z
		goto		chk_min
;      
		pagesel		ClrA
		call		ClrA
		movf		Y0, W
		movwf		AARGB1
		movf		Y1, W
		movwf		AARGB2
		call		FLO2432
		movlw		LOW lim_min_1k	;   
		call		Prog_To_B
		call		TALTB32	;A<B? ; 1-, 0-
		pagesel		$
		iorlw		0
		btfss		STATUS, Z
		retlw		2	; 
		
		pagesel		Prog_To_B
		movlw		LOW lim_max_1k	;   
		call		Prog_To_B
		call		TAGTB32	;A>B? ; 1-, 0-
		pagesel		$
		iorlw		0
		btfss		STATUS, Z
		retlw		2	; 

		pagesel		BEQUA
		call		BEQUA
		call		ClrA
		movf		Y2, W
		movwf		AARGB1
		movf		Y3, W
		movwf		AARGB2
		call		FLO2432
		call		FPS32
		movlw		LOW lim_amp_1k	;   
		call		Prog_To_B
		call		TALTB32	;A<B? ; 1-, 0-
		pagesel		$
		iorlw		0
		btfss		STATUS, Z
		retlw		1	; 
		retlw		0	;     96...1022

;--------------------------
min_to_Y0
		movf		INDF, W
		movwf		Y0	; 
		incf		FSR, F
min_to_Y1
		movf		INDF, W
		movwf		Y1	; 
		goto		chk_end
;--------------------------
max_to_Y2
		movf		INDF, W
		movwf		Y2	; 
		incf		FSR, F
max_to_Y3
		movf		INDF, W
		movwf		Y3	; 
		goto		chk_end

;===============================================================
; 20-     ()
;
;         19
; F(1) =  Sum x(t) * (Cos(2*Pi*t/20 - j*Sin(2*Pi*t/20))
;         t=0
;
;===============================================================
DFT
		pagesel		Clr_XY
		call 		Clr_XY
		clrf		Num_p	;    
DFT_loop
		; Re
		movlw 		HIGH Table
		movwf 		PCLATH
		movlw		LOW Cos_n - 1
		addwf		Num_p, W
		call		Table		;    Cos(x)
		pagesel		Cos_To_B
		call		Cos_To_B	;   W   Cos
		call		ADC_To_A
		call		FLO2432 ;to 32 bit floating point
		call		FPM32	;A=ADC(Num_p)*Cos(Num_p)
		movlw		X0
		call		Copy_To_B
		call		FPA32	; A=ADC*Cos+Re
		movlw		X0
		call		Copy_From_A ;  
		;Im
		movlw 		HIGH Table
		movwf 		PCLATH
		movlw		LOW Sin_n - 1
		addwf		Num_p, W
		call		Table		;    Sin(x)
		pagesel		Cos_To_B
		call		Cos_To_B	;   W   Sin
		call		ADC_To_A
		call		FLO2432 ;to 32 bit floating point
		call		FPM32	;A=ADC(Num_p)*Sin(Num_p)
		movlw		Y0
		call		Copy_To_B
		call		FPA32	; A=ADC*Sin+Re
		movlw		Y0
		call		Copy_From_A ;  

		pagesel		$		
		incf		Num_p, F
		movlw		.20
		subwf		Num_p, W
		btfss		STATUS, Z
		goto		DFT_loop

; 
		movlw		X0		;Re
		movwf		Temp2	; 
		movlw		I_Re0
		btfss		PORTC, U_I
		movlw		U_Re0
		movwf		Temp1	; 
		pagesel		Copy
		call		Copy
		pagesel		$
		
		movlw		Y0		;Im
		movwf		Temp2	; 
		movlw		I_Im0
		btfss		PORTC, U_I
		movlw		U_Im0
		movwf		Temp1	; 
		pagesel		Copy
		call		Copy
		pagesel		$
		return

;=======================================================================
;     R=U/I
;
;  U_Re + j*U_Im     U_Re*I_Re + U_Im*I_Im        I_Re*U_Im - U_Re*I_Im
;  -------------- = ------------------------ + j*-----------------------
;  I_Re + j*I_Im      I_Re*I_Re + I_Im*I_Im       I_Re*I_Re + I_Im*I_Im
;
;=======================================================================
Div_UI
		;  
		pagesel		Copy_To_A
		movlw		I_Re0
		call		Copy_To_A	; I_Re -> A
		call		BEQUA		; A -> B
		call		FPM32		; A=A*B, .. =I_Re*I_Re
		movlw		Y0
		call		Copy_From_A	; Y=I_Re*I_Re
		movlw		I_Im0
		call		Copy_To_A	; I_Im -> A
		call		BEQUA		; A -> B
		call		FPM32		; A=A*B, .. =I_Im*I_Im
		movlw		Y0
		call		Copy_To_B
		call		FPA32		;A=I_Re*I_Re + I_Im*I_Im
		movlw		Y0
		call		Copy_From_A	;  
		;   
		movlw		U_Re0
		call		Copy_To_A	;U_Re -> A
		movlw		I_Re0
		call		Copy_To_B	;I_Re -> B
		call		FPM32		;A=U_Re*I_Re
		movlw		X0
		call		Copy_From_A
		movlw		U_Im0
		call		Copy_To_A	;U_Im -> A
		movlw		I_Im0
		call		Copy_To_B	;I_Im -> B
		call		FPM32		;A=U_Im*I_Im
		movlw		X0
		call		Copy_To_B
		call		FPA32		;A=U_Re*I_Re + U_Im*I_Im
		movlw		Y0
		call		Copy_To_B	;B=
		call		FPD32		;A=A/B
		movlw		Z_Re0
		call		Copy_From_A	;  
		;  
		movlw		U_Re0
		call		Copy_To_A	;U_Re -> A
		movlw		I_Im0
		call		Copy_To_B	;I_Im -> B
		call		FPM32		;A=U_Re*I_Im
		movlw		X0
		call		Copy_From_A
		movlw		I_Re0
		call		Copy_To_A	;I_Re -> A
		movlw		U_Im0
		call		Copy_To_B	;U_Im -> B
		call		FPM32		;A=I_Re*U_Im
		movlw		X0
		call		Copy_To_B
		call		FPS32		;A=I_Re*U_Im - U_Re*I_Im
		movlw		Y0
		call		Copy_To_B	;B=
		call		FPD32		;A=A/B
		movlw		Z_Im0
		call		Copy_From_A	;  
		pagesel		$
;======================================================
;   U  I,    
;     
;------------------------------------------------------
Swap_UI
		movlw		U_Im0
		movwf		Temp1
		movlw		I_Im0
		movwf		Temp2
		movlw		.8		;  
		movwf		Count1
swap_loop
		movf		Temp1, W	;  U
		movwf		FSR
		movf		INDF, W
		movwf		X1	;  U  X1
		movf		Temp2, W	;  I
		movwf		FSR
		movf		INDF, W
		movwf		X2	;  I  X2
		movf		X1, W
		movwf		INDF
		movf		Temp1, W	;  U
		movwf		FSR
		movf		X2, W
		movwf		INDF
		
		decf		Temp1, F ;    
		decf		Temp2, F ; 
		decfsz		Count1, F
		goto		swap_loop
		return
;=======================================================================
;    
;
;          Zmeas - Zs               Zmcor          Zs - short circuit impedance
; Zx= --------------------  = ---------------      Zmeas - uncorrected measured impedance
;      1 - (Zmeas - Zs)*Yo     1 - Zmcor*Yo        Yo - open parallel admittance
;                                                  Zmcor= Zmeas - Zs
;   - Zmeas  Z_Re, Z_Im
;   - Zx  Yx   Z_Re, Z_Im
;=======================================================================
Comp_Zin
		pagesel		Copy_To_A
		;  ,  
		movlw		Z_Re0
		call		Copy_To_A
		pagesel		$
		movlw		LOW Zs_Re_1k
		btfss		Flags, freq
		movlw		LOW Zs_Re_100
		pagesel		EEPROM_To_B
		call		EEPROM_To_B
		call		FPS32	;A = Zmcor_Re=Zmeas_Re - Zs_Re
		movlw		U_Re0
		call		Copy_From_A	;    U   
		;  ,  
		movlw		Z_Im0
		call		Copy_To_A
		pagesel		$
		movlw		LOW Zs_Im_1k
		btfss		Flags, freq
		movlw		LOW Zs_Im_100
		pagesel		EEPROM_To_B
		call		EEPROM_To_B
		call		FPS32	;A = Zmcor_Im = Zmeas_Im - Zs_Im
		movlw		U_Im0
		call		Copy_From_A	;    U   
; Yo * Zmcor = (Y_Re*Zmcor_Re - Yo_Im*Zmcor_Im) +
;              (Yo_Re*Zmcor_Im + Y_Im*Zmcor_Re)j
		movlw		U_Re0
		call		Copy_To_A
		pagesel		$
		movlw		LOW Yo_Re_1k
		btfss		Flags, freq
		movlw		LOW Yo_Re_100
		pagesel		EEPROM_To_B
		call		EEPROM_To_B
		call		FPM32
		movlw		I_Re0
		call		Copy_From_A	; Y_Re*Zmeas_Re

		movlw		U_Im0
		call		Copy_To_A
		pagesel		$
		movlw		LOW Yo_Im_1k
		btfss		Flags, freq
		movlw		LOW Yo_Im_100
		pagesel		EEPROM_To_B
		call		EEPROM_To_B
		call		FPM32	; Yo_Im*Zmeas_Im
		call		BEQUA
		movlw		I_Re0
		call		Copy_To_A
		call		FPS32	; Yo_Re*Zmeas_Re - Yo_Im*Zmeas_Im
		call		BEQUA
		movlw		LOW E0
		call		Prog_To_A ; A=1
		call		FPS32	; 1 - (Yo_Re*Zmeas_Re - Yo_Im*Zmeas_Im)
		movlw		I_Re0
		call		Copy_From_A	;   

		movlw		U_Re0
		call		Copy_To_A
		pagesel		$
		movlw		LOW Yo_Im_1k
		btfss		Flags, freq
		movlw		LOW Yo_Im_100
		pagesel		EEPROM_To_B
		call		EEPROM_To_B
		call		FPM32
		movlw		I_Im0
		call		Copy_From_A	;Y_Im*Zmeas_Re

		movlw		U_Im0
		call		Copy_To_A
		pagesel		$
		movlw		LOW Yo_Re_1k
		btfss		Flags, freq
		movlw		LOW Yo_Re_100
		pagesel		EEPROM_To_B
		call		EEPROM_To_B
		call		FPM32	; Yo_Re*Zmeas_Im
		call		BEQUA
		movlw		I_Im0
		call		Copy_To_A
		call		FPA32
		movlw		b'10000000'
		xorwf		AARGB0, F	;  -/+
		movlw		I_Im0
		call		Copy_From_A

		pagesel		$
		btfsc		Flags, f_p	;0-  , 1-
		call		Swap_UI		;     U  I
		call		Div_UI		; U/I,    Z   Y
		return

;=======================================================================
;      EEPROM
;=======================================================================
Save_Zin
		banksel		Flags
		movlw		Z_Re0
		pagesel		Copy_To_A
		call		Copy_To_A
		pagesel		$
		btfss		Flags, freq
		goto		save_1
		movlw		LOW Yo_Re_1k	;  1kHz
		btfss		Flags, f_p
		movlw		LOW Zs_Re_1k
		goto		save_2
save_1
		movlw		LOW Yo_Re_100	;  100Hz
		btfss		Flags, f_p
		movlw		LOW Zs_Re_100
save_2		
		pagesel		A_To_EEPROM
		call		A_To_EEPROM

		movlw		Z_Im0
		call		Copy_To_A
		pagesel		$
		btfss		Flags, freq
		goto		save_3
		movlw		LOW Yo_Im_1k	;  1kHz
		btfss		Flags, f_p
		movlw		LOW Zs_Im_1k
		goto		save_4
save_3
		movlw		LOW Yo_Im_100	;  100Hz
		btfss		Flags, f_p
		movlw		LOW Zs_Im_100
save_4
		pagesel		A_To_EEPROM
		call		A_To_EEPROM
		pagesel		$
		return
;-----------------------------------------------------------------------------
;  Sin(2*PI*t/20)     CCPR2L:CCPCON<5:4>
Load_Sine_Val
		movlw		HIGH Sine_Table
		movwf		PCLATH
		decf		Sine_step, W ;     1 
		call		Sine_Table
		movwf		Sine_val
		movlw		b'11001111'
		andwf		CCP2CON
		rrf			Sine_val, F
		btfsc		STATUS, C
		bsf			CCP2CON, 4	; ,   (0)
		rrf			Sine_val, F
		btfsc		STATUS, C
		bsf			CCP2CON, 5	; ,  N 1
		movf		Sine_val, W
		andlw		0x3F
		movwf		CCPR2L		;  - 
		decfsz		Sine_step,F	; 
		goto		lsv_1		;   /
		movlw		.20			; 
		movwf		Sine_step
		return
lsv_1	nop			;   /
		return
;------------------------- Delay -------------------------
;	 
;       

Delay_01_sec		; 0.1 
		Dly24	D'31249'   ; 0.1/(4/20000000)/16=156250-1=156249
		goto	DoDly24

Delay_05_sec		; 0.5 
		Dly24	D'156249'   ; 0.5/(4/20000000)/16=156250-1=156249
		goto	DoDly24

Delay_5_ms	; 5 
		Dly24	D'1562'   ; 0.005/(4/20000000)/16=1562.5=1562
		goto	DoDly24
		
Delay_200_us	; 200 
		Dly24	D'62'   ; 0.0002/(4/20000000)/16=62.5=62
		goto	DoDly24

DoDly24		;16 Tcy per loop
		movlw   H'FF'      ;Start with -1 in W
		addwf   Dly0,F     ;LSB decrement
		btfsc   STATUS,C   ;was the carry flag set?
		clrw               ;If so, 0 is put in W
		addwf   Dly1,F     ;Else, we continue.
		btfsc   STATUS,C
		clrw               ;0 in W
		addwf   Dly2,F
		btfsc   STATUS,C
		clrw               ;0 in W
		iorwf   Dly0,W     ;Inclusive-OR all variables
		iorwf   Dly1,W     ;together to see if we have reached
		iorwf   Dly2,W     ;0 on all of them.
		btfss   STATUS,Z   ;Test if result of Inclusive-OR's is 0
		goto    DoDly24
		return


;==============================================
; - - - - - - -        LCD        - - - - - - -

;	        
SecLine		movlw		0xC0

;	 
CmdLCD	movwf	Temp_LCD
;		bcf		_RS
		swapf	Temp_LCD, W
		andlw	0x0F
		movwf	PORTB
		bsf		_E
		nop
		nop
		nop
		bcf		_E
		movf	Temp_LCD, W
		andlw	0x0F
		movwf	PORTB
		bsf		_E
		nop
		nop
		nop
		bcf		_E
;		clrf		PORTB
		call	Delay_200_us
		return


;	  ASCII  
NumLCD	andlw		0x0F		; 
		iorlw		0x30		; ASCII
;	 ASCII 
CharLCD	movwf		Temp_LCD
SendLCD	swapf		Temp_LCD, W
		andlw		0x0F
		iorlw		b'00010000'	; RS=1
		movwf		PORTB
		bsf		_E
		nop
		nop
		nop
		bcf		_E
		movf		Temp_LCD, W
		andlw		0x0F
		iorlw		b'00010000'	; RS=1
		movwf		PORTB
Send	bsf		_E
		nop
		nop
		nop
		bcf		_E
		clrf		PORTB
		call		Delay_200_us
		return



CursorHome	movlw		0x02		;    
			goto		LongSend
ClrDSP		movlw		1		;  
LongSend	call		CmdLCD
			goto		Delay_5_ms

DispDot		movlw		"."
			goto		CharLCD

Disp0		movlw		"0"
			goto		CharLCD

DispSP		movlw		" "
			goto		CharLCD

;-----------------------------------------------------------
;       LCD
Read_String
			movwf		Count1
			decf		Count1,F ;  
			movlw 		HIGH Table
			movwf 		PCLATH
get_next_s
			movf		Count1,W
			call		Table
			andlw		0xFF	;    
			btfsc		STATUS, Z
			return
			call		CharLCD
			incf		Count1,F
 			goto		get_next_s

;---------------------- Load CGRAM LCD ---------------------
; 
Load_ZG
			movlw		b'01001000' ; AC in CGRAM=8
			call		CmdLCD
			movlw 		HIGH Table
			movwf 		PCLATH
			movlw		.16		;2   8 
			movwf		Count1
			movlw		LOW  omega-1
			movwf		Count2	;  

get_s		call		Table	;   
			call		CharLCD
			incf		Count2,F
			movf		Count2,W
			decfsz		Count1,F
			goto		get_s
			return

;----------------------------------------------------------
;    W   BCD0...4
; 
Disp_Full
			movwf		FSR		;     LCD
next_byte
			swapf		INDF,W
			call		NumLCD
			movf		INDF,W
			call		NumLCD
			;,     BCD0
			movlw		BCD0
			subwf		FSR,W
			btfsc		STATUS,Z
			return
			decf		FSR,F
			goto		next_byte

;---------------------- BCD ---------------------
;	      
BCD		movlw		0x20
		movwf		T1
		clrf		BCD0
		clrf		BCD1
		clrf		BCD2
		clrf		BCD3
		clrf		BCD4

BcdLoop	rlf		AARGB3, F
		rlf		AARGB2, F
		rlf		AARGB1, F
		rlf		AARGB0, F

		rlf		BCD0, F
		rlf		BCD1, F
		rlf		BCD2, F
		rlf		BCD3, F
		rlf		BCD4, F
		decfsz		T1, F
		goto		Adjust
		return

Adjust	movlw		.5
		movwf		Count2

		movlw		BCD0
		movwf		FSR
		goto		ADloop+1

ADloop	incf		FSR, F
		call		Adjbcd
		decfsz		Count2, F
		goto		ADloop
		goto		BcdLoop

Adjbcd	movlw		0x03
		addwf		INDF, W
		movwf		T0		
		btfsc		T0, 3		
		movwf		INDF
		movlw		0x30
		addwf		INDF, W
		movwf		T0
		btfsc		T0, 7
		movwf		INDF
		return

;=======================================================================
;       
; NZ -   
;=======================================================================
Disp_A	
		btfss		AARGB0,7 ; "-"
		goto		dsp_1
		bcf			AARGB0, 7	; "-"
		movlw		"-"
		call		CharLCD
dsp_1
		clrf		Y0		; 
		movlw		LOW	E9	;  (19) 
		movwf		Y1
;   > ?
cmp_A_E
		movf		Y1, W
		pagesel		Prog_To_B
		call		Prog_To_B
		call		TAGTB32	; A>E ?
		pagesel		$
		iorlw		0		; 0 - , 1 - 
		btfss		STATUS, Z
		goto		A_GT_E
		movlw		4
		addwf		Y1, F	; . 
		incf		Y0,	F
		movlw		.8		;  ( 0  7,   )
		subwf		Y0, W
		btfss		STATUS, Z
		goto		cmp_A_E	; 
		decf		Y0, F

;,  Y0 -  
A_GT_E	;A >= E
		incf		Y0, W	; . ,     
		movwf		Y1		;    3   
		bcf			STATUS, C
		rlf			Y1, F
		rlf			Y1, F	;  (1..8)*4
		movlw		LOW E9
		addwf		Y1, W	; +
		pagesel		Prog_To_B
		call		Prog_To_B
		call		FPD32	;A=A/B,  B=1E(+/-3*N)
		call		INT3232	;   
		pagesel		$
		call		BCD
;   
		bsf			Flags, L_Z ;    
		movlw		4
		movwf		NZ	;     

		movlw		BCD4
		call		DispBCD
		movlw		BCD4
		call		DispBCD
		
		movlw		BCD3
		call		DispBCD
		movlw		BCD3
		call		DispBCD

		movlw		BCD2
		call		DispBCD
		movlw		BCD2
		call		DispBCD

		bcf			Flags, L_Z ;   
		movlw		BCD1
		call		DispBCD
		movf		NZ, F
		btfsc		STATUS, Z
		goto		prefix
		call		DispDot	; 
		movlw		BCD1
		call		DispBCD_2

		movlw		BCD0
		call		DispBCD_2
		movlw		BCD0
		call		DispBCD_2

prefix
		btfss		Flags, calibr	;    
		call		DispSP
		movlw		LOW _pref-1
		addwf		Y0, W
		call		Table
		iorlw		0
		btfss		STATUS, Z
		goto		CharLCD
		return		;      ( ),   

		
;---------------------- BCD to LCD ---------------------
;	      
DispBCD_2
		movf		NZ, F
		btfsc		STATUS, Z
		return
DispBCD	
		movwf		FSR
		swapf		INDF,F
		movf		INDF,W
		btfss		Flags,L_Z ;1 -    
		goto		chk_NZ
		andlw		0x0F
		btfsc		STATUS,Z
		return		; 
		bcf			Flags,L_Z ;      
chk_NZ
		movf		NZ, F
		btfsc		STATUS, Z
		goto		Disp0 ;   ,  0
		decf		NZ, F
		movf		INDF,W
		call		NumLCD
		return

;-------------------------------------------------------
;   /     -
;
;	  B
IncB
		bsf			Flags, const_change	;   
        incf		BARGB2, F
		btfsc		STATUS, Z
		incf		BARGB1, F
		goto		ShowX

;	  B
DecB
		bsf			Flags, const_change	;   
        movf		BARGB2, F
		btfsc		STATUS, Z
		decf		BARGB1, F
		decf		BARGB2, F

ShowX	
		movlw		BEXP
		movwf		Temp2	;  -   
		movlw		AARGB0
		movwf		Temp1	;  -   
		pagesel		Copy
		call		Copy
		pagesel		$		
		
		bcf			Flags, L_Z	;   
		movlw		4	;  
		movwf		NZ

		call		BCD
		call		SecLine
		movlw		BCD1
		call		DispBCD
		call		DispDot
		movlw		BCD1
		call		DispBCD
		movlw		BCD0
		call		DispBCD
		movlw		BCD0
		call		DispBCD
		
		call		Delay_05_sec
		return
;-----------------------
Save_Const
; -   Y1
		movf		Y1, W
		pagesel		B_To_EEPROM
		call		B_To_EEPROM
		pagesel		$
		return
		
;=======================================================
;    Ubat
;
;=======================================================
Disp_Ubat
		; 
		banksel		ADCON0
		movlw		b'10001001' ;Fosc/32,  AN1,   .
		movwf		ADCON0
		call		Delay_200_us	;    Chold ADC
		bsf			ADCON0,GO	; - 
		btfsc		ADCON0,GO
		goto		$-1		;   
		;     
		movlw		b'10000001' ;Fosc/32,  AN0,   .
		movwf		ADCON0

		pagesel		ClrA
		call		ClrA
		banksel		ADRESL
		movf		ADRESL, W	;  
		banksel		AARGB2
		movwf		AARGB2
		movf		ADRESH,W
		movwf		AARGB1
		call		FLO32
		movlw		LOW K_Ubat
		call		EEPROM_To_B
		call		FPM32
		pagesel		$
   		movlw		LOW _Ubat
		call		Read_String
		call		Disp_A
		movlw		"V"
		call		CharLCD
		return
		
;=======================================================
; .    0x700
; ( 256     )
		include "tables.inc"   


		
;////////////////////////////////////////////////////////////////////////////////////
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;                   P A G E   N 1
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;////////////////////////////////////////////////////////////////////////////////////

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;     PIC16 24 BIT FLOATING POINT LIBRARY
;    1-   
;    pagesel
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define P16_MAP1 0
#define P16_MAP2 1
		org		0x800

        include "math16.inc"
        include "fp32.a16"
        include	"taxxb32.a16"


;-------------------------------------------------------
;
;  /     FPL32
;
;-------------------------------------------------------
Clr_ADC
		movlw		ADC_val + .39	;    
		movwf		FSR
		movlw		.40		; 
		movwf		Count1
		goto		ClrLoop	

;	  X, Y
Clr_XY
		movlw		Y0	;    X, Y
		movwf		FSR
		movlw		.8		; 
		movwf		Count1
		goto		ClrLoop	

ClrB	movlw		BEXP	;   
		goto		ClrA+1

ClrA	movlw		AEXP	;   
		movwf		FSR
		movlw		4	; 
		movwf		Count1

ClrLoop
		clrf		INDF	;  
		decf		FSR, F	;  
		decfsz		Count1, F
		goto		ClrLoop
		return

;-------------------------------------------------------
;	   EEPROM   A
EEPROM_To_A
		movwf		EE_ADR	;    EEPROM
		movlw		AEXP
		goto		ee_1

;	   EEPROM   B
EEPROM_To_B
		movwf		EE_ADR	;    EEPROM
		movlw		BEXP
ee_1
		movwf		FSR
		movlw		4	; 
		movwf		Count1
EE_read_loop
	    call		ReadEEPROM
		banksel		BEXP
		movwf		INDF
		incf		EE_ADR, F
		decf		FSR, F
		decfsz		Count1, F
		goto		EE_read_loop
		return

;	 EEPROM
ReadEEPROM
		movf		EE_ADR,W ;
		banksel		EEADR 	;  2
		movwf		EEADR	;   EEPROM
		banksel		EECON1	; 3
		bcf			EECON1,EEPGD ; EEPROM 
		bsf			EECON1,RD    ; 
		banksel		EEDATA	; 2
		movf		EEDATA,W	; W = EEDATA
		return

;-------------------------------------------------------
;	  BARG  EEPROM
;   EEPROM   W
B_To_EEPROM
		movwf		EE_ADR
		movlw		BEXP
		goto		w_ee_1
		
;	  AARG  EEPROM
;   EEPROM   W
A_To_EEPROM
		movwf		EE_ADR
		movlw		AEXP
w_ee_1
		movwf		FSR
		movlw		4	; 
		movwf		Count1
EE_write_loop
		movf		INDF,W
		movwf		EE_DATA
		call		WriteEEPROM
		banksel		BEXP
		incf		EE_ADR, F
		decf		FSR, F
		decfsz		Count1, F
		goto		EE_write_loop
		return

;	 EEPROM
WriteEEPROM
		banksel		EECON1	;3
		btfsc		EECON1,WR
		goto		$-1
		banksel		EE_ADR
		movf		EE_ADR,W
		banksel		EEADR	;2
		movwf		EEADR
		banksel		EE_DATA
		movf		EE_DATA,W
		banksel		EEDATA	;2
		movwf		EEDATA
		banksel		EECON1	;3
		bcf			EECON1,EEPGD
		bsf			EECON1,WREN
		movlw		0x55
		movwf		EECON2
		movlw		0xAA
		movwf		EECON2
		bsf			EECON1,WR
		nop
		bcf			EECON1,WREN
		return

;-------------------------------------------------------
;	 " "  (4 ) 
; Temp1 =   -    
; Temp2 =   -    

;CEQUA		movlw		CX		; C=A
Copy_From_A
		movwf		Temp1		; Xw=A
		movlw		AEXP
		movwf		Temp2
		goto		Copy

BEQUA		movlw		AEXP		; B=A
Copy_To_B	movwf		Temp2		; B=Xw
		movlw		BEXP
		goto		Copy_B

;AEQUF		movlw		FX		; A=F
Copy_To_A
		movwf		Temp2		; A=Xw
		movlw		AEXP

Copy_B	movwf		Temp1
Copy	movlw		4		;  
		movwf		Count1
Copy_Loop
		movf		Temp2, W
		movwf		FSR
		movf		INDF, W
		movwf		Temp3
		movf		Temp1, W
		movwf		FSR
		movf		Temp3, W
		movwf		INDF
		decf		Temp1, F ;    
		decf		Temp2, F ; 
		decfsz		Count1, F
		goto		Copy_Loop
		return

;---------------------------------------------------
;	    Cos(x)   B
Cos_To_B
		movwf		f_tmp	;      Cos
		bcf			STATUS,	C
		rlf			f_tmp, F
		rlf			f_tmp, F ;  4
		movlw		BEXP
		movwf		FSR
		movlw		4	; 
		movwf		Count1
Cos_read_loop
		movlw 		HIGH Table
		movwf 		PCLATH
		movlw		LOW _Cos-1
		addwf		f_tmp, W
		call		Table	;   Cos
		pagesel		$
		movwf		INDF	;  BARG
		incf		f_tmp, F;
		decf		FSR, F
		decfsz		Count1, F
		goto		Cos_read_loop
		return

;---------------------------------------------------
;   (4 )     reg. A
Prog_To_A
		movwf		f_tmp	;     
		decf		f_tmp, F	;    
		movlw		AEXP
		movwf		FSR
		goto		prog_1
;   (4 )     reg. B
Prog_To_B
		movwf		f_tmp	;     
		decf		f_tmp, F	;    
		movlw		BEXP
		movwf		FSR
prog_1
		movlw		4	; 
		movwf		Count1
ptb_loop
		movlw 		HIGH Table
		movwf 		PCLATH
		movf		f_tmp, W
		call		Table	; 
		pagesel		$
		movwf		INDF	;  BARG
		incf		f_tmp, F;
		decf		FSR, F
		decfsz		Count1, F
		goto		ptb_loop
		return

;---------------------------------------------------
;	      A
ADC_To_A
		call		ClrA
		movf		Num_p, W	;  
		movwf		f_tmp
		bcf			STATUS, C
		rlf			f_tmp, F	;  2 ,   2
		movlw		ADC_val
		addwf		f_tmp, W
		movwf		FSR
		movf		INDF, W	;  
		movwf		AARGB1
		incf		FSR
		movf		INDF, W	;  
		movwf		AARGB2
		return




        
        END

